;Graphics FROM http://home.cogeco.ca/~neilroy/free_gfx_1.html
Graphics 640,480,32,1
SetBuffer BackBuffer() ; Turn Back Buffering On

Const EFAIL = 0 ;Our Escape Code when things did not go correctly
Const SOK = 1 ;Our Escape Code if everything worked

Type Enemy ;Our Enemy
	Field hEnemy;The handle to our enemies image
	Field x,y;Our enemies position
	Field dir;Our enemies direction
End Type 

Global Gravity# = 0.2;Gravity To Make the Player Go Down
Global MapGFX = LoadAnimImage("land_tiles.tga",32,32,0,50);Land Tiles
Global PlayerGFX = LoadAnimImage("Player.bmp",32,32,0,7);PlayerTiles
Global MapSizeX = 0;Our Maps Width in Tiles
Global MapSizeY = 0;Our Maps Height in Tiles
Global ScreenRezX = 640;Our Screen Resolution X
Global ScreenRezY = 480;Our Screen Resolution Y
Global OffsetX = 0;Our XOffset
Global NewOffsetX = 0;Our Offset so that we can have a smooth transition
Global PlayerX = 0;Our Players Y Position
Global PlayerY = 0;Our Players Y Position
Global PlayerYVel# = 0;Our Players Y Velocity
Global PlayerAnimation = 5;Player Frame
Global PlayerSides = False ;Player Collision on the left and right
Global PlayerUp = False ;PlayerCollision on the Top
Global PlayerDown = False ;PlayerCollsions on the bottom
Global EndGFX = LoadImage("End.bmp")
Global EndX = 0 ;the levels end position
Global EndY = 0 ;the levels end position

MaskImage MapGFX,255,0,255;Make the part that is meant to be transparent transparent
Dim Map(2,0,0);Our Map, the reason for the size of the array is because we want to have two layers, one scenery and one Solid one


LoadLevel("test.lvl")
While Not KeyDown(1)
	Cls
	 ;make sure that we can scroll the screen
	If PlayerX>OffsetX+610 Then NewOffsetX = NewOffsetX + 100 ;if our character comes near to the edge of the screen then scroll the environment
	If PlayerX<OffsetX+30 And OffsetX > 0 Then NewOffsetX = NewOffsetX - 100;if our character comes near to the edge of the screen then scroll the environment
	While NewOffsetX-OffsetX>0 ;While the newOffset is not equel to the old offset
		Cls
		OffsetX = OffsetX + 2;change the offset
		Origin -OffsetX,0;apply the changes
		DrawImage PlayerGFX,PlayerX,PlayerY,PlayerAnimation
		DrawEnemies
		DrawLevel
		Flip
	Wend
	;Preform Tweening
	While NewOffsetX-OffsetX<0 ;While the newOffset is not equel to the old offset 
		Cls 
		OffsetX = OffsetX - 2;change the offset
		Origin -OffsetX,0;apply the changes
		DrawImage PlayerGFX,PlayerX,PlayerY,PlayerAnimation;draw the player
		DrawEnemies
		DrawLevel;draw the player
		Flip
	Wend
	
	If PlayerCollisions()= True ;Preform Collisions if player got to exit point put the finishing text to "you win" and end
		finish$ = "YOU WIN"
		Exit
	EndIf 
	If KeyDown(203) And PlayerSides = False;If LeftKey is down and no collisions
		PlayerX = PlayerX-2 ;Move the player left
		PlayerAnimation = PlayerAnimation-1 ;Change the players animation State
		If PlayerAnimation<0 Then PlayerAnimation = 3 ;loop the animation
	EndIf
	If KeyDown(205) And PlayerSides = False;If RightKey is down and no collisions
		PlayerX = PlayerX+2 ;Move the player left
		PlayerAnimation = PlayerAnimation+1 ;Change the players animation State
		If PlayerAnimation>6 Then PlayerAnimation = 5 ;loop the animation
	EndIf
	If PlayerDown = True And PlayerYVel >0;The Player Hit the ground
		PlayerYVel = 0 ;The player has no Y axis movement
	EndIf 
	If KeyDown(200) And PlayerDown = True;If Upkey is hit and the player is on the ground
		PlayerYVel = -6;make the player jump
	EndIf
	Text 20,10,r + " " + PlayerYVel
	DrawImage PlayerGFX,PlayerX,PlayerY,PlayerAnimation
	If PlayerDown = False Or PlayerYVel<0 ;there were no below our character collisions
		PlayerY = PlayerY + PlayerYVel;move the player
		PlayerYVel = PlayerYVel + Gravity;Apply Gravity
	EndIf
	If UpdateEnemies() = False 
		finish$ = "YOU LOSE :("
		Exit ;if the player hit the enemy then exit the loop
	EndIf
		
	DrawEnemies
	DrawLevel 
	Flip
Wend

Text 320,240,finish$
Flip
Delay 100
WaitKey

;Clean Up all the memory we used
FreeImage MapGFX
FreeImage PlayerGFX
FreeImage EndGFX
For e.Enemy = Each Enemy;loop through all of the enemies
	FreeImage e\hEnemy;free the image
	Delete e;delete the type
Next


Function PlayerCollisions()
	;Reset the collisions variables
	PlayerUp = False
	PlayerSides = False
	PlayerDown = False
	;Start Collision Detection
	For x = 0 To MapSizeX
		For y = 0 To MapSizeY
			If Map(1,x,y)>0 ;if there is something occupying the current x,y position in the Map array
				If ImagesCollide(PlayerGFX,PlayerX+1,PlayerY,PlayerAnimation,MapGFX,x*32,y*32,Map(1,x,y)) Then PlayerSides = True ;IF the player collided with the current tile on his right
				If ImagesCollide(PlayerGFX,PlayerX-1,PlayerY,PlayerAnimation,MapGFX,x*32,y*32,Map(1,x,y)) Then PlayerSides = True ;IF the player collided with the current tile on his left
				If ImagesCollide(PlayerGFX,PlayerX,PlayerY+PlayerYVel,PlayerAnimation,MapGFX,x*32,y*32,Map(1,x,y)) Then PlayerDown = True;IF the player collided with the current tile below him
				If ImagesCollide(PlayerGFX,PlayerX,PlayerY-PlayerYVel,PlayerAnimation,MapGFX,x*32,y*32,Map(1,x,y)) Then PlayerUp = True;IF the player collided with the current tile Above Him
			EndIf
		Next
	Next
	If ImagesCollide(PlayerGFX,PlayerX,PlayerY,PlayerAnimation,EndGFX,EndX,EndY,0) Return True ;if the player collided with the ending point then return true
	Return False
End Function 

Function DrawEnemies();Function to Draw all of our Enemies
	For e.Enemy = Each Enemy ;Loop through all of our enemies
		DrawImage e\hEnemy,e\x,e\y ;Draw the enemy
	Next
End Function

Function UpdateEnemies();Updates all of our enemies
	For x = 0 To MapSizeX
		For y = 0 To MapSizeY
			If Map(1,x,y)>0 ;if there is something occupying the current x,y position in the Map array
				For e.Enemy = Each Enemy ;loop through all of our enemies
					If ImagesCollide(e\hEnemy,e\x+e\dir,e\y,0,MapGFX,x*32,y*32,Map(1,x,y)) Then e\dir=e\dir*-1 ;IF the enemy collided with the current tile change his direction				Next
				Next
			EndIf
		Next
	Next
	For e.Enemy = Each Enemy ;loop through all of our enemies again
		If ImagesCollide(e\hEnemy,e\x,e\y,0,PlayerGFX,PlayerX,PlayerY,PlayerAnimation) Then Return False ;if the player hit the enemy then return false
		e\x = e\x+e\dir ;apply direction		
	Next
	Return True
End Function 
	
Function DrawLevel();Function to Draw our Level
	For x = 0 To MapSizeX ;loop from 0 to our map size
		For y = 0 To MapSizeY ;Loop from 0 to our maps y size
			DrawImage MapGFX,x*32,y*32,Map(0,x,y);Copy the apropriet frame onto the screen
			DrawImage MapGFX,x*32,y*32,Map(1,x,y);Copy the apropriet frame onto the screen
		Next
	Next
	DrawImage EndGFX,EndX,EndY ;Draw our ending graphics
End Function 
			
Function LoadLevel(filename$) ;Loads Our Level
	in = ReadFile(filename$);Open A File For Reading And Obtain a Handle to it
	If in = 0 Then Return EFAIL;if our file did not load then return a failure
	;Read Our MapX and MapY values
	MapSizeX = ReadInt(in) ;Get the X size of the map
	MapSizeY = ReadInt(in) ;Get the Y size of the map
	Dim Map(2,MapSizeX,MapSizeY);Re Dimensionalize our map with the size of the level
	
	;READ OUR SCENERY LEVEL
	r = 0;The FeedBack we get from our files
	x = 0
	y = 0 ;zero our position in the array
	While Not r = -2
		r = 0 ;ReZero our Feedback Variable
		While r>-1
			r = ReadInt(in)
			If r>=0 And r<=50 And x<MapSizeX And y<MapSizeY;if its within the range of our tiles
				Map(0,x,y) = r ;Assign the variable
			EndIf 
			x = x +1 ;increment our x position
		Wend
		x = 0;Zero our x position because we have just finished a line
		y = y +1;increment our y position
	Wend
	;READ OUR PHYSICAL LEVEL
	r = 0;The FeedBack we get from our files
	x = 0
	y = 0;zero our position in the array
	While Not r = -2
		r = 0 ;ReZero our Feedback Variable
		While r>-1
			r = ReadInt(in)
			If r>0 And r<=50 And x<MapSizeX And y<MapSizeY ;if its within the range of our tiles
				Map(1,x,y) = r ;Assign the variable
			EndIf 
			If r=-3 ;if we encounter a player creation code
				PlayerX = x*32;set player position
				PlayerY = y*32;set player position
				r = 0;reset the return variable so it doesnt exit the loop
			EndIf
			If r=-4 ;if we encounter an end point
				r = 0
				EndX = x*32
				EndY = y*32
			EndIf
			If r=-5 ;if we encounter an enemy creation point
				e.Enemy = New Enemy ;Create a new enemy
				e\hEnemy = LoadImage("Enemy.bmp") ;load his image
				e\x = x*32 ;set his x position
				e\y = y*32-10 ;set his y position
				e\dir = ReadInt(in) ;set his direction
				r= 0;reset the return variable so it doesnt exit the loop
			EndIf
			x = x +1 ;increment our x position
		Wend
		x = 0;Zero our x position because we have just finished a line
		y = y +1;increment our y position
	Wend
	
	CloseFile(in);we have finished with our file so we can close it
	Return SOK
End Function 
	
		
				
	
	
	
	